unit unitlib;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils;

{$LINKLIB c}

const
  {$ifdef cpu64}
    USBLC_LIB = 'libusblc8m64.so';
  {$else}
    USBLC_LIB = 'libusblc8m32.so';
  {$endif}

  FM_01V20    = $0114;
  FM_01V21    = $0115;
  FM_01V22    = $0116;


function ls_libversion : word; cdecl; external USBLC_LIB;
procedure ls_initialize(pipesize, packetlength : integer); cdecl; external USBLC_LIB;
function ls_enumdevices : integer; cdecl; external USBLC_LIB;
function ls_getfwversion(idx: integer): word; cdecl; external USBLC_LIB;
function ls_getvendorname(idx: integer): pchar; cdecl; external USBLC_LIB;
function ls_getproductname(idx: integer): pchar; cdecl; external USBLC_LIB;
function ls_getserialnumber(idx: integer): pchar; cdecl; external USBLC_LIB;
function ls_devicecount : byte; cdecl; external USBLC_LIB;
function ls_currentdeviceindex : integer; cdecl; external USBLC_LIB;
function ls_opendevicebyindex(idx: integer): integer; cdecl; external USBLC_LIB;
function ls_opendevicebyserial(pcserialnum: pchar): integer; cdecl; external USBLC_LIB;
function ls_closedevice : integer; cdecl; external USBLC_LIB;
procedure ls_waitforpipe(dwtimeout : dword); cdecl; external USBLC_LIB;
function ls_waitforpipecount(nNumberOfBytes : integer; dwtimeout : dword) : integer; cdecl; external USBLC_LIB;
function ls_getpipe(lpBuffer : Pointer; nNumberOfBytesToRead : Integer) : Integer; cdecl; external USBLC_LIB;
function ls_setpacketlength(packetlength : integer) : integer; cdecl; external USBLC_LIB;
function ls_getfps : dword; cdecl; external USBLC_LIB;
function ls_getsensortype(var wsensortype, wpixelcount: word; timeout : dword): integer; cdecl; external USBLC_LIB;
function ls_geterrorstring(iErr : integer) : PChar; cdecl; external USBLC_LIB;

function ls_getsensorname(wsensortype : word) : pchar; cdecl; external USBLC_LIB;
function ls_getminmaxtime(wsensortype : word; var tmin, tmax : dword) : integer; cdecl; external USBLC_LIB;

function ls_savesettings(timeout : dword) : integer; cdecl; external USBLC_LIB;

function ls_getadcconfig(var wconfig : word; timeout : dword) : Integer; cdecl; external USBLC_LIB;
function ls_getadcpga1(var wpga : word; timeout : dword) : Integer; cdecl; external USBLC_LIB;
function ls_getadcpga2(var wpga : word; timeout : dword) : Integer; cdecl; external USBLC_LIB;
function ls_getadcpga3(var wpga : word; timeout : dword) : Integer; cdecl; external USBLC_LIB;
function ls_getadcoffset1(var woffset : word; timeout : dword) : Integer; cdecl; external USBLC_LIB;
function ls_getadcoffset2(var woffset : word; timeout : dword) : Integer; cdecl; external USBLC_LIB;
function ls_getadcoffset3(var woffset : word; timeout : dword) : Integer; cdecl; external USBLC_LIB;

function ls_setadcconfig(wConfig : word; timeout : dword) : Integer; cdecl; external USBLC_LIB;
function ls_setadcpga1(wPGA : word; timeout : dword) : Integer; cdecl; external USBLC_LIB;
function ls_setadcpga2(wPGA : word; timeout : dword) : Integer; cdecl; external USBLC_LIB;
function ls_setadcpga3(wPGA : word; timeout : dword) : Integer; cdecl; external USBLC_LIB;
function ls_setadcoffset1(woffset : word; timeout : dword) : Integer; cdecl; external USBLC_LIB;
function ls_setadcoffset2(woffset : word; timeout : dword) : Integer; cdecl; external USBLC_LIB;
function ls_setadcoffset3(woffset : word; timeout : dword) : Integer; cdecl; external USBLC_LIB;


//------------------------------------------------------------------------------
function ls_setmode(ucmode : byte; timeout : dword) : integer; cdecl; external USBLC_LIB;
function ls_setstate(ucstate : byte; timeout : dword) : integer; cdecl; external USBLC_LIB;
function ls_setinttime(dwinttime, timeout : dword) : integer; cdecl; external USBLC_LIB;
function ls_setextdelay(dwextdelay, timeout : dword) : integer; cdecl; external USBLC_LIB;
function ls_setcfg1(uccfg1 : byte; timeout : dword) : integer; cdecl; external USBLC_LIB;
function ls_setsofttrigtime(dwsofttrigtime, timeout : dword) : integer; cdecl; external USBLC_LIB;

function ls_getmcusensortype(var wsensortype : word; timeout : dword) : integer; cdecl; external USBLC_LIB;
function ls_getmode(var ucmode : byte; timeout : dword) : integer; cdecl; external USBLC_LIB;
function ls_getstate(var ucstate : byte; timeout : dword) : integer; cdecl; external USBLC_LIB;
function ls_getinttime(Var dwinttime : dword; timeout : dword) : integer; cdecl; external USBLC_LIB;
function ls_getextdelay(var dwextdelay : dword; timeout : dword) : integer; cdecl; external USBLC_LIB;
function ls_getcfg1(var uccfg1 : byte; timeout : dword) : integer; cdecl; external USBLC_LIB;
function ls_getsofttrigtime(var dwsofttrigtime : dword; timeout : dword) : integer; cdecl; external USBLC_LIB;
function ls_getminmaxsfttrigtime(var dwmintime, dwmaxtime : dword; timeout : dword) : integer; cdecl; external USBLC_LIB;

function ls_getpacketlength(var packetlength : integer; timeout : dword) : integer; cdecl; external USBLC_LIB;
function ls_customfirmware(var dwcustom : dword; timeout : dword) : integer; cdecl; external USBLC_LIB;

implementation

end.

